/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.syn.models.tools

import com.persagy.base.extensions.toInt
import com.persagy.database.SFilter
import com.persagy.mybatis.SMybatisDao
import com.persagy.server.datacenter.models.entities.dictnew.DefFuncId
import com.persagy.server.datacenter.models.entities.objects.GeneralSystem
import com.persagy.server.syn.Opts
import com.persagy.server.syn.controllers.obj.ObjectFromToControllers
import com.persagy.service.SObjectService
import com.persagy.service.utils.SSpringContextUtil
import org.slf4j.LoggerFactory

/**
 * 系统工具
 *
 * @author wx  <zhangweixin@sagacloud.com>
 * @date  2020/10/21 19:34
 */
object SystemUtil {

    /** 日志 */
    private val logger = LoggerFactory.getLogger(ObjectFromToControllers::class.java)
    /** 信息点 */
    private val dictDefFuncIdService = SObjectService(SMybatisDao(DefFuncId::class.java))
    /** 配置 */
    private val opts: Opts by lazy {
        SSpringContextUtil.getBean(Opts::class.java) as Opts
    }

    /**
     * 系统转换工具
     *
     * @param projectId     项目 id
     * @param groupCode     集团编码
     * @param mapObj        中台数据对象
     * @return 返回结果
     */
    fun systemDataConversions(projectId: String,groupCode: String, mapObj: HashMap<String, Any?>): GeneralSystem {
        /** 查建楼层型字典 */
        val dictDefFuncIdList = dictDefFuncIdService.select(SFilter.eq("groupCode", groupCode), SFilter.eq("classCode", mapObj["classCode"].toString())).exec()
        val mapEx = HashMap<String, Any?>()
        val mapCode = HashMap<String, Any?>()
        /** 遍历项目类型字典 */
        for (explainProject in dictDefFuncIdList) {
            /** 输入类型 */
            mapEx[explainProject.code!!] = explainProject.dataType
            mapCode[explainProject.code!!] = explainProject.category
        }

        val generalSystem = GeneralSystem()
        generalSystem.projectId = projectId

        for (key in mapObj.keys) {
            val containsKey = mapEx.containsKey(key)
            if (containsKey){
                if (key != "id"&& key!="name"&&key!="localId"&&key!="localName"&&key!="defaultQRCode"
                    &&key!="qRCodePic"&&key!="cadId"&&key!="bimId"){
                    val containsKey1 = mapCode.containsKey(key)
                    if (containsKey1){
                        val any = mapCode[key].toString()
                        if (any == "STATIC"){
                            when(mapEx[key].toString()) {
                                "INTEGER" -> {
                                    if (generalSystem.infos.isNullOrEmpty()){
                                        generalSystem.infos = HashMap<String,Any?>()
                                    }
                                    generalSystem.infos!![key] = mapObj[key]!!.toInt()
                                }
                                "DOUBLE" -> {
                                    if (generalSystem.infos.isNullOrEmpty()){
                                        generalSystem.infos = HashMap<String,Any?>()
                                    }
                                    generalSystem.infos!![key] = mapObj[key]!!.toString().toDoubleOrNull()
                                }
                                "BOOLEAN" -> {
                                    if (generalSystem.infos.isNullOrEmpty()){
                                        generalSystem.infos = HashMap<String,Any?>()
                                    }
                                    generalSystem.infos!![key] = mapObj[key]!!.toString().toBoolean()
                                }
                                "STRING" -> {
                                    if (generalSystem.infos.isNullOrEmpty()){
                                        generalSystem.infos = HashMap<String,Any?>()
                                    }
                                    generalSystem.infos!![key] = mapObj[key]!!.toString()
                                }
                                "DATETIME" -> {
                                    if (generalSystem.infos.isNullOrEmpty()){
                                        generalSystem.infos = HashMap<String,Any?>()
                                    }
                                    generalSystem.infos!![key] = mapObj[key]!!.toString()
                                }
                                "ATTACHMENT" -> {
                                    if (generalSystem.infos.isNullOrEmpty()){
                                        generalSystem.infos = HashMap<String,Any?>()
                                    }
                                    generalSystem.infos!![key] = mapObj[key]!!.toString()
                                }
                                "OBJECT" -> {
                                    if (generalSystem.infos.isNullOrEmpty()){
                                        generalSystem.infos = HashMap<String,Any?>()
                                    }
                                    generalSystem.infos!![key] = mapObj[key]!!.toString()
                                }
                                "ENUM" -> {
                                    if (generalSystem.infos.isNullOrEmpty()){
                                        generalSystem.infos = HashMap<String,Any?>()
                                    }
                                    generalSystem.infos!![key] = mapObj[key]!!.toString()
                                }
                                "MENUM" -> {
                                    if (generalSystem.infos.isNullOrEmpty()){
                                        generalSystem.infos = HashMap<String,Any?>()
                                    }
                                    generalSystem.infos!![key] = mapObj[key]!!.toString()
                                }
                                else -> {
                                    if (generalSystem.infos.isNullOrEmpty()){
                                        generalSystem.infos = HashMap<String,Any?>()
                                    }
                                    generalSystem.infos!![key] = mapObj[key]!!.toString()
                                }
                            }
                        }else{
                            if (generalSystem.infos.isNullOrEmpty()){
                                generalSystem.infos = HashMap<String,Any?>()
                            }
                            generalSystem.infos!![key] = mapObj[key]!!.toString()
                        }
                    }

                } else {
                    when(key) {
                        "id" -> generalSystem.id =  mapObj[key]!!.toString()
                        "name" -> generalSystem.name =  mapObj[key]!!.toString()
                        "localId" -> generalSystem.localId =  mapObj[key]!!.toString()
                        "localName" -> generalSystem.localName =  mapObj[key]!!.toString()
                        "defaultQRCode" -> generalSystem.defaultQRCode =  mapObj[key]!!.toString()
                        "qRCodePic" -> generalSystem.qRCodePic =  mapObj[key]!!.toString()
                        "cadId" -> generalSystem.cadId =  mapObj[key]!!.toString()
                        "bimId" -> generalSystem.bimId =  mapObj[key]!!.toString()
                    }
                }

            } else {
                //                if (zoneSpace.infos.isNullOrEmpty()){
//                    zoneSpace.infos = HashMap<String,Any?>()
//                }
//                zoneSpace.infos!![key] =  mapObj[key]!!.toString()
            }
        }

        return generalSystem
    }

    /**
     * 系统工具
     *
     * @param projectId         项目 id
     * @param generalSystem     系统对象
     * @return 返回结果
     */
    fun systemTools(projectId: String,generalSystem: GeneralSystem): ArrayList<HashMap<String,Any?>> {
        var list = ArrayList<HashMap<String,Any?>>()
        val hashMap = HashMap<String, Any?>()
        hashMap["id"] = generalSystem.id
        hashMap["name"] = generalSystem.name
        hashMap["projectId"] = projectId
        hashMap["objType"] = "generalSystem"
        hashMap["classCode"] = generalSystem.classCode
        if (!generalSystem.localName.isNullOrEmpty()){
            hashMap["localName"] = generalSystem.localName
        }
        if (!generalSystem.localId.isNullOrEmpty()){
            hashMap["localId"] = generalSystem.localId
        }
        if (!generalSystem.defaultQRCode.isNullOrEmpty()){
            hashMap["defaultQRCode"] = generalSystem.defaultQRCode
        }
        if (!generalSystem.qRCodePic.isNullOrEmpty()){
            hashMap["qRCodePic"] = generalSystem.qRCodePic
        }
        if (!generalSystem.cadId.isNullOrEmpty()){
            hashMap["cadId"] = generalSystem.cadId
        }
        if (!generalSystem.bimId.isNullOrEmpty()){
            hashMap["bimId"] = generalSystem.bimId
        }
        if (!generalSystem.infos.isNullOrEmpty()){
            for (key in generalSystem.infos!!.keys){
                hashMap[key] = generalSystem.infos!![key]
            }
        }

        list.add(hashMap)
        return list
    }



}